var map = L.map('map', {});

// PAINEIS
map.createPane('pane_0').style.zIndex = 499;
map.createPane('pane_1').style.zIndex = 498;
map.createPane('pane_2').style.zIndex = 497;
map.createPane('pane_3').style.zIndex = 496;
map.createPane('pane_4').style.zIndex = 495;

var baseMaps = {};
var overlayMaps = {};

// CAMADAS BASE
var googleStreet = L.tileLayer('http://{s}.google.com/vt/lyrs=m,h&x={x}&y={y}&z={z}',{
	maxZoom: 20,
	subdomains:['mt0','mt1','mt2','mt3'],
	attribution: '<a href="https://www.google.at/permissions/geoguidelines/attr-guide.html">Map data ©2021 Google</a>'
});
baseMaps["Google Street"] = googleStreet;

var googleSatellite = L.tileLayer('http://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}',{
	maxZoom: 20,
	subdomains:['mt0','mt1','mt2','mt3'],
	attribution: '<a href="https://www.google.at/permissions/geoguidelines/attr-guide.html">Map data ©2021 Google</a>'
});
googleSatellite.addTo(map);
baseMaps['Google Satellite'] = googleSatellite;

// CAMADAS VETORIAIS
var _kamera_LPT = L.geoJSON(_kamera_LPT_data, {
			pointToLayer: function(geoJsonPoint, latlng) {return L.circleMarker(latlng, {pane: 'pane_0'})},
			style: {
						opacity: 1.0,
						fillOpacity: 1.0,
						radius: 5.0,
						weight: 0.0,
						color: 'rgba(35, 35, 35, 1.00)',
						fillColor: 'rgba(196, 60, 57, 1.00)'
			},
			onEachFeature: function (feature, layer){
				layer.on({click: clickedFeature});
				layer.bindPopup(function (layer) {
					return '<h4>CAMADA: kamera LPT</h4><br/>'  +
							'<b>NR:</b>&ensp;' + feature.properties['nr'] + '<br/>' +
							'<b>OPIS:</b>&ensp;' + feature.properties['opis'] + '<br/>' 
				});
			}
}).addTo(map);
overlayMaps['kamera_LPT'] = _kamera_LPT;

var _kamera_sta_opozycyjna = L.geoJSON(_kamera_sta_opozycyjna_data, {
			pointToLayer: function(geoJsonPoint, latlng) {return L.circleMarker(latlng, {pane: 'pane_1'})},
			style: {
						opacity: 1.0,
						fillOpacity: 1.0,
						radius: 4.6,
						weight: 0.0,
						color: 'rgba(35, 35, 35, 1.00)',
						fillColor: 'rgba(190, 207, 80, 1.00)'
			},
			onEachFeature: function (feature, layer){
				layer.on({click: clickedFeature});
				layer.bindPopup(function (layer) {
					return '<h4>CAMADA: kamera stałopozycyjna</h4><br/>'  +
							'<b>ID:</b>&ensp;' + feature.properties['id'] + '<br/>' +
							'<b>NR:</b>&ensp;' + feature.properties['nr'] + '<br/>' +
							'<b>OPIS:</b>&ensp;' + feature.properties['opis'] + '<br/>' 
				});
			}
}).addTo(map);
overlayMaps['kamera_sta_opozycyjna'] = _kamera_sta_opozycyjna;

var _kamera_z_termowizj_ = L.geoJSON(_kamera_z_termowizj__data, {
			pointToLayer: function(geoJsonPoint, latlng) {return L.circleMarker(latlng, {pane: 'pane_2'})},
			style: {
						opacity: 1.0,
						fillOpacity: 1.0,
						radius: 4.0,
						weight: 2.0,
						color: 'rgba(61, 128, 53, 1.00)',
						fillColor: 'rgba(84, 176, 74, 1.00)'
			},
			onEachFeature: function (feature, layer){
				layer.on({click: clickedFeature});
				layer.bindPopup(function (layer) {
					return '<h4>CAMADA: kamera z termowizją</h4><br/>'  +
							'<b>ID:</b>&ensp;' + feature.properties['id'] + '<br/>' +
							'<b>NR:</b>&ensp;' + feature.properties['nr'] + '<br/>' +
							'<b>OPIS:</b>&ensp;' + feature.properties['opis'] + '<br/>' 
				});
			}
}).addTo(map);
overlayMaps['kamera_z_termowizj_'] = _kamera_z_termowizj_;

var _kamery_obrotowe = L.geoJSON(_kamery_obrotowe_data, {
			pointToLayer: function(geoJsonPoint, latlng) {return L.circleMarker(latlng, {pane: 'pane_3'})},
			style: {
						opacity: 1.0,
						fillOpacity: 1.0,
						radius: 4.0,
						weight: 2.0,
						color: 'rgba(50, 87, 128, 1.00)',
						fillColor: 'rgba(72, 123, 182, 1.00)'
			},
			onEachFeature: function (feature, layer){
				layer.on({click: clickedFeature});
				layer.bindPopup(function (layer) {
					return '<h4>CAMADA: kamery obrotowe</h4><br/>'  +
							'<b>ID:</b>&ensp;' + feature.properties['id'] + '<br/>' +
							'<b>NR KAMERY:</b>&ensp;' + feature.properties['nr kamery'] + '<br/>' +
							'<b>OPIS:</b>&ensp;' + feature.properties['opis'] + '<br/>' 
				});
			}
}).addTo(map);
overlayMaps['kamery_obrotowe'] = _kamery_obrotowe;

var _punktykamerowe2024 = L.geoJSON(_punktykamerowe2024_data, {
			pointToLayer: function(geoJsonPoint, latlng) {return L.circleMarker(latlng, {pane: 'pane_4'})},
			style: {
						opacity: 1.0,
						fillOpacity: 1.0,
						radius: 7.0,
						weight: 7.0,
						color: 'rgba(241, 3, 3, 1.00)',
						fillColor: 'rgba(255, 255, 255, 1.00)'
			},
			onEachFeature: function (feature, layer){
				layer.on({click: clickedFeature});
				layer.bindPopup(function (layer) {
					return '<h4>CAMADA: punktykamerowe2024</h4><br/>'  +
							'<b>ID:</b>&ensp;' + feature.properties['id'] + '<br/>' +
							'<b>NRPUNKTU:</b>&ensp;' + feature.properties['nrpunktu'] + '<br/>' +
							'<b>OPIS:</b>&ensp;' + feature.properties['opis'] + '<br/>' 
				});
			}
}).addTo(map);
overlayMaps['punktykamerowe2024'] = _punktykamerowe2024;

//Função que dá zoom sobre a feição clicada
function clickedFeature(e) {
	var feature = e.target;
	if (feature.feature.geometry.type == 'Point' ) {
		map.setView(feature.getLatLng(), 16);
	} else {
		map.fitBounds(feature.getBounds());
	}
}

// LEGENDA
var legend = L.control({position: 'bottomright'});
legend.onAdd = function (map) {
	var div = L.DomUtil.create('div', 'info legend');
	div.innerHTML = '<dl>';
	div.innerHTML += 	'<dt class="_kamera_LPT_lgd"><svg class="legendIcon"><circle cx="9" cy="9" r="5" stroke="rgba(35, 35, 35, 1.00)" stroke-width="2" fill="rgba(196, 60, 57, 1.00)"></svg>kamera LPT</dt>';
	div.innerHTML += 	'<dt class="_kamera_sta_opozycyjna_lgd"><svg class="legendIcon"><circle cx="9" cy="9" r="5" stroke="rgba(35, 35, 35, 1.00)" stroke-width="2" fill="rgba(190, 207, 80, 1.00)"></svg>kamera stałopozycyjna</dt>';
	div.innerHTML += 	'<dt class="_kamera_z_termowizj__lgd"><svg class="legendIcon"><circle cx="9" cy="9" r="5" stroke="rgba(61, 128, 53, 1.00)" stroke-width="2" fill="rgba(84, 176, 74, 1.00)"></svg>kamera z termowizją</dt>';
	div.innerHTML += 	'<dt class="_kamery_obrotowe_lgd"><svg class="legendIcon"><circle cx="9" cy="9" r="5" stroke="rgba(50, 87, 128, 1.00)" stroke-width="2" fill="rgba(72, 123, 182, 1.00)"></svg>kamery obrotowe</dt>';
	div.innerHTML += 	'<dt class="_punktykamerowe2024_lgd"><svg class="legendIcon"><circle cx="9" cy="9" r="5" stroke="rgba(241, 3, 3, 1.00)" stroke-width="2" fill="rgba(255, 255, 255, 1.00)"></svg>punktykamerowe2024</dt>';
	div.innerHTML += '</dl>';
	return div
}
legend.addTo(map);

//ESCALA
L.control.scale({
	maxWidth: 250,
	imperial: false
}).addTo(map);

// CONTROLE DE CAMADAS
L.control.layers(baseMaps, overlayMaps, {
	position: 'topright',
	collapsed: false,
	sortLayers: true
}).addTo(map);

function layerON (event){
	var className = event.name + '_lgd';
	var legendItems = document.getElementsByClassName(className);
	for (var i = 0; i < legendItems.length; i++) {
		legendItems[i].style.display = 'block';
	}
}

function layerOFF (event){
	var className = event.name + '_lgd';
	var legendItems = document.getElementsByClassName(className);
	for (var i = 0; i < legendItems.length; i++) {
		legendItems[i].style.display = 'none';
	}
}

map.on('overlayadd', layerON);
map.on('overlayremove', layerOFF);

// CALCULA A AREA QUE COBRE TODAS AS CAMADAS
var bounds = {xmin: 180, ymin: 90, xmax: -180, ymax: -90};
for (var layer in overlayMaps) {
	var layerBounds = overlayMaps[layer].getBounds();
	if (bounds.xmin > layerBounds.getSouthWest().lng) {bounds.xmin = layerBounds.getSouthWest().lng};
	if (bounds.ymin > layerBounds.getSouthWest().lat) {bounds.ymin = layerBounds.getSouthWest().lat};
	if (bounds.xmax < layerBounds.getNorthEast().lng) {bounds.xmax = layerBounds.getNorthEast().lng};
	if (bounds.ymax < layerBounds.getNorthEast().lat) {bounds.ymax = layerBounds.getNorthEast().lat};
}
map.fitBounds([
	[bounds.ymin, bounds.xmin],
	[bounds.ymax, bounds.xmax]
]);
